]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- add _clean_env with _preserve_env support
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
36eccf0d
ER
15%__rm /bin/rm --interactive=never
16
33040789 17# Build system path macros.
18#
bddadece
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
f93109a0 21%__autopoint autopoint --force
22
83094b62 23%__gettextize { \
8a995cff 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 25 gettextize --copy --force --no-changelog; \
97589b6e 26 else \
3241033b 27 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
3241033b 30 cp -f po/Makevars{.template,}; \
8a995cff 31 fi; \
8a995cff 32}
f93109a0 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
fb59e475 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
c26f1b59 39%__libtoolize libtoolize --copy --force --install
33040789 40
384e1b2b 41# Path to top of build area.
f5f7156a 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 43
81e450f7
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
6a5eda77 47%dependencytracking %{nil}
3241033b 48
e5da9169
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
7bf0526c 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
c9d403e1 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
19f42054 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
810fa5c4 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 73# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
7b6f1112 79 for (i = 1; i in I; i++) { A=0; \
810fa5c4 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
09a90176 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 95 %{filter_out}
96}')
97
98e7f050
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
810fa5c4 104%rpmldflags %(awk 'BEGIN {
c05a0741 105 split("%{?optldflags}",I);
810fa5c4 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
25f52d1a 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
8ef644e5 124#-----------------------------------------------------------------
125#
126# Generate a command which cleans environment, leaving only the
127# most important variables.
128# If any spec requires any additional environment it should
129# redefine %_preserve_env in following manner:
130#
131# # ADDITIONAL_VAR is required because [a good reason here]
132# %{expand:%%define _preserve_env %_preserve_env ADDITIONAL_VAR}
133
134%_preserve_env HOME TMP TMPDIR
135
136%_clean_env env -i %(awk 'BEGIN {
137 split("%{?_preserve_env:%_preserve_env}",P);
138 for ( i in P ) {
139 p = P[ i ];
140 if ( ENVIRON[ p ] ) {
141 val = ENVIRON[ p ];
142 gsub( /[\\\\"$`]/, "\\\\\\&", val );
143 printf( "\\"" p "=" val "\\" ");
144 }
145 }
146}')
147
9c404149 148#-----------------------------------------------------------------
9f4ce098 149%configure2_13 { \
9c404149
AM
150 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
151 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
152 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 153 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 154 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 155 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 156 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
157 %{?__cc:CC="%{__cc}" ; export CC ; } \
158 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 159 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 160 --host=%{_target_platform} \
9c404149
AM
161 --prefix=%{_prefix} \
162 --exec-prefix=%{_exec_prefix} \
163 --bindir=%{_bindir} \
164 --sbindir=%{_sbindir} \
165 --sysconfdir=%{_sysconfdir} \
166 --datadir=%{_datadir} \
167 --includedir=%{_includedir} \
168 --libdir=%{_libdir} \
169 --libexecdir=%{_libexecdir} \
170 --localstatedir=%{_localstatedir} \
171 --sharedstatedir=%{_sharedstatedir} \
172 --mandir=%{_mandir} \
173 --infodir=%{_infodir} \
b6c5da52 174 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 175 %{dependencytracking} \
9c404149
AM
176}
177
89f4ca1f 178%__cmake /usr/bin/cmake
39b9534b
ER
179%cmake { \
180CC="%{__cc}" \
181CXX="%{__cxx}" \
182CFLAGS="%{rpmcflags}" \
183CXXFLAGS="%{rpmcxxflags}" \
12513dc1 184LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
185%{__cmake} \
186}
187
188# override __scons to add -j4 in your ~/.rpmmacros for parallel make
189%__scons /usr/bin/scons
190%scons { \
191%{__scons} \
5c76736d
ER
192 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
193 CFLAGS="${CFLAGS:-%rpmcflags}" \
194 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
195 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 196 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
197 %{?__cc:CC="%{__cc}"} \
198 %{?__cxx:CXX="%{__cxx}"} \
199 libsuffix=%{_lib} \
200 prefix=%{_prefix} \
39b9534b
ER
201}
202
6339d32d 203# waf. see waf.spec
89f4ca1f 204# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
205%__waf /usr/bin/waf
206%waf { \
6339d32d
ER
207CC="%{__cc}" \
208CXX="%{__cxx}" \
9e244007 209CPP="%{__cpp}" \
6339d32d
ER
210CFLAGS="%{rpmcflags}" \
211CXXFLAGS="%{rpmcxxflags}" \
212%{__waf} \
6339d32d
ER
213}
214
4a6b0d54 215#----------------------------------------------------------------
9bacbb5b 216#%configure_cache 0
fe6c4bdd 217%configure_cache_file %{buildroot}.configure.cache
73f832b3 218
57f4166d 219%configure {./configure \
4a6b0d54
AF
220 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
221 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 222 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 223 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 224 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 225 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
226 %{?__cc:CC="%{__cc}"} \
227 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 228 --host=%{_target_platform} \
4a6b0d54
AF
229 --build=%{_target_platform} \
230 --prefix=%{_prefix} \
231 --exec-prefix=%{_exec_prefix} \
232 --bindir=%{_bindir} \
233 --sbindir=%{_sbindir} \
234 --sysconfdir=%{_sysconfdir} \
235 --datadir=%{_datadir} \
236 --includedir=%{_includedir} \
237 --libdir=%{_libdir} \
238 --libexecdir=%{_libexecdir} \
239 --localstatedir=%{_localstatedir} \
240 --sharedstatedir=%{_sharedstatedir} \
241 --mandir=%{_mandir} \
242 --infodir=%{_infodir} \
b6c5da52 243 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 244 %{dependencytracking} \
9bacbb5b 245 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
246}
247
b3b1397b
ER
248# overload to insert debuginfo package
249%prep \
250%if 0%{?_enable_debug_packages}\
251%{debug_package}\
252%endif\
253%%prep\
254%{nil}
255
9c404149 256# Location of autoconf macros
7f0f4a79 257%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 258
e2804f99 259# Location of omf files
7f0f4a79 260%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 261
e987a186 262# Location of pkgconfig files
9a4e877a 263%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
264# noarch pkgconfig files
265%_npkgconfigdir /usr/share/pkgconfig
e987a186 266
486b0b5f 267# Location of desktop files
268%_desktopdir /usr/share/applications
86dff2d0 269%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 270
481463e9 271# Location of pixmaps for applnk/desktop files
e1f0a822 272%_pixmapsdir /usr/share/pixmaps
9c404149 273
481463e9 274# Location of themable icons for applnk/desktop files
b36c8e2a 275%_iconsdir /usr/share/icons
276
e987a186
JB
277# Location of fonts directories
278%_fontsdir /usr/share/fonts
279
b3282f3f 280# Location of Gtk and associated libraries documentation
fe6c4bdd 281%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 282
fc4d7771 283# Location of KDE documentation
fe6c4bdd 284%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 285
5869828c 286# unsermake script
287%__unsermake /usr/share/unsermake/unsermake
288
9c404149
AM
289# Current date
290%date %(LC_ALL="C" date +"%a %b %d %Y")
291
9c404149
AM
292# Example files, programs, scripts...
293%_examplesdir /usr/src/examples
294
c8f7e820 295# Alternative kernel type/version
261729d9 296%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 297
8377d27d 298# The directory holding Linux kernel sources
261729d9 299%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 300
9c404149 301# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 302%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 303
8f74418b 304# Requires name = version-release
d514eecd 305%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
8bf3719d 306
f5f7156a
ER
307%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
308%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
309%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
310%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
311%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
312%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 313
d514eecd
ER
314# XXX: why epoch 0 is stripped?
315%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
316%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
01a9f990 317
c94807f3 318%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 319
320# kernel version-release handling
95125403
ER
321%__kernel_ver %{expand:%%global __kernel_ver %( \\
322 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
323 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
324 echo ${Z:-ERROR}; \\
1a7d3518 325)}%__kernel_ver
95125403 326
c94807f3
ER
327%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
328%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
329%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
330%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 331
6262f001
ER
332# `uname -r` to be used in @release field
333%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
334
e00dd7f6 335# sgml macros
3241033b
ER
336%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
337%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
338%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
339%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
340%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
341%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 342%docbook_sgmlcat_fix() { for l in \
343'' \
344' -- default decl --' \
345'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
346' -- hacks for opensp --' \
347'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
348'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
349'' \
350; do echo $l; done >> %1 \
351}
352
eea64748
ER
353# vim - "
354
4f044018
ER
355# minimum file size needed for compressed documents.
356# just smaller files than this get larger when compressed.
a88ae20f
ER
357# some stats:
358# - 0 byte file compressed was 25 bytes .gz
359# - 39 byte file was compressed as 57
360# - with test/test.spec@man 158 byte file was compressed also 158
361%_min_compress_bytes 159
4f044018 362
9c404149
AM
363#-----------------------------------------------------------------
364# find and gzip all files in %{_mandir} and %{infodir}
365#
366# Requires: xargs, find
367#
368#%no_install_post_compress_docs 1
369%__spec_install_post_compress_docs { \
53d5af13 370%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 371 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 372 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 373 echo "Compress man pages: $i"; \
4f044018
ER
374 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
375 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
376 find $RPM_BUILD_ROOT$i -type l | while read a; do \
377 m=$(readlink $a); \
378 rm -f $a; \
379 echo .so ${m##*/} > $a; \
380 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
381 done; \
4f044018 382 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
383 fi; \
384 done; \
728ad671
JB
385 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
386 echo "Compress info pages: %{_infodir}"; \
387 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
388 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
389 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 390 fi; \
53d5af13 391}; __spec_install_post_compress_docs } }
9c404149
AM
392
393#-----------------------------------------------------------------
394# Strip executable binaries and shared object files
395#
396# Requires: find, awk, strip, cut, xargs
397#
a2ad2754
JB
398# Special macros which affect this process:
399#%no_install_post_strip 1 # disable stripping at all
400#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
401#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
402#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
403#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
404#
9c404149 405%__spec_install_post_strip {%{!?debug: \
53d5af13 406%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 407if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
408 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
409 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
410 if [ "$modulelist" ]; then \
411 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 412 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
413 echo "$modulelist" | xargs -l512 chmod u+w; \
414 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
415 echo "DONE"; \
416 fi; \
eea64748 417 fi; \
0ac49134 418 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
419 if [ -n "$filelist" ]; then \
420 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
421 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
422 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 423 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 424 if [ -n "$elfexelist" ]; then \
4d5370ac 425 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
426 chmod u+w $elfexelist; \
427 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
428 echo "DONE"; \
429 fi; \
430 if [ -n "$elfsharedlist" ]; then \
4d5370ac 431 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
432 chmod u+w $elfsharedlist; \
433 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
434 echo "DONE"; \
435 fi; \
436 if [ -n "$archiveslist" ]; then \
4d5370ac 437 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
438 chmod u+w $archiveslist; \
439 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
440 echo "DONE"; \
441 fi; \
98a06bad 442 fi; \
0ac49134
ER
443 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
444 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
445 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 446 if [ -n "$filelist_all" ]; then \
4d5370ac 447 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 448 chmod u+w $filelist_all; \
f89ccb5f 449 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 450 echo "DONE"; \
9c404149 451 fi; \
f89ccb5f 452 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 453 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 454 chmod u+w $filelist_unneeded; \
f89ccb5f 455 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 456 echo "DONE"; \
8f74418b 457 fi; \
f89ccb5f 458 if [ -n "$filelist_debug" ]; then \
4d5370ac 459 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 460 chmod u+w $filelist_debug; \
f89ccb5f 461 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 462 echo "DONE"; \
9f0d4f36 463 fi; \
53d5af13 464fi; }; __spec_install_post_strip } } }
3241033b 465
fc5d7e20 466#-----------------------------------------------------------------
467# remove all RPATH from executable binaries and shared object files
468#
469# Requires: find, awk, cut, xargs, chrpath, uname
470#
a2ad2754
JB
471# Special macros which affect this process
472#%no_install_post_chrpath 1 # disable chrpath at all
473#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
474#
fc5d7e20 475%__spec_install_post_chrpath {%{!?debug: \
53d5af13 476%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 477if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 478 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 479 if [ -n "$files" ]; then \
d5517264 480 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 481 fi; \
98a06bad 482 if [ -n "$objs" ]; then \
4d5370ac 483 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
484 echo "$objs" | \
485 while read file; do \
486 rpath= ; \
487 chmod u+w "$file"; \
5541bf26 488 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
489 case $dir in \
490 '$ORIGIN' ) \
491 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
492 else rpath="$rpath:$dir" ; fi ; \
493 continue ; \
494 ;; \
495 esac ; \
f9abaddb
AM
496 newdir=$(readlink -m "$dir"); \
497 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
498 case $dir in \
499 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
500 echo "remove-rpath: $dir in $file"; \
501 ;; \
502 * ) \
503 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
504 else rpath="$rpath:$dir" ; fi ; \
505 ;; \
506 esac ; \
507 done ; \
508 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
509 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
510 done; \
511 fi; \
53d5af13 512fi; }; __spec_install_post_chrpath } } }
3241033b 513
d366d7e0
AM
514#-----------------------------------------------------------------
515# Find all shared object files with unresolved symbols. Warn
516# and terminate if any found (termination can be turned off by define).
517#%no_install_post_check_so 1
518%__spec_install_post_check_so { \
519 __spec_install_post_check_so() { \
520 fail=0; \
521 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 522 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 523 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
524 done ; \
525 echo " DONE"; \
14ae3117 526 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
527}; __spec_install_post_check_so }}
528
d72c185f 529#-----------------------------------------------------------------
ccb8ae8d 530# Find and gzip all kernel modules
531#
532# Requires: find
533#
fe6c4bdd 534#%no_install_post_compress_modules 1
ccb8ae8d 535%__spec_install_post_compress_modules { \
53d5af13 536%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 537 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 538 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
539 if [ "$q" ]; then \
540 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
541 echo "$q" | xargs -r %{__gzip} -9nf; \
542 echo "DONE"; \
543 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
544 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
545 fi; \
3241033b 546 fi; \
53d5af13 547}; __spec_install_post_compress_modules } }
9c404149 548
ef64802f
ER
549# Remove common Perl files we don't package
550%__spec_install_post_perl_clean {\
551%{!?no_install_post_perl_clean: \
552%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
553} }
554
83094b62 555#-----------------------------------------------------------------
0e4cb4dd 556# Update GConf2 schemas
83094b62 557#
558# Requires: GConf2
559#
46885239 560%gconf_schema_install() \
307ac6c9
ER
561 umask 022; \
562 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
563 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 564%{nil}
46885239 565
566%gconf_schema_uninstall() \
24336a54 567if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 568 umask 022; \
24336a54
ER
569 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
570 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 571fi; \
f93109a0 572%{nil}
573
574#-----------------------------------------------------------------
575# Update desktop MIME database
c0a4caa0 576# requires: desktop-file-utils
c3bcd10e 577%update_desktop_database() {{ \
f93109a0 578 umask 022; \
fb59e475 579 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
580};} \
581%{nil}
f93109a0 582
c3bcd10e
ER
583%update_desktop_database_post %update_desktop_database
584
585%update_desktop_database_postun() {{ \
f27cf2fd 586if [ "$1" = "0" ]; then \
c00bf95c 587 %update_desktop_database \
f27cf2fd 588fi; \
c00bf95c
MB
589};} \
590%{nil}
f93109a0 591
fb59e475 592#-----------------------------------------------------------------
593# Update shared MIME info database
594# requires: shared-mime-info
595#
c3bcd10e 596%update_mime_database() {{ \
fb59e475 597 umask 022; \
598 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
599};} \
600%{nil}
fb59e475 601
602#-----------------------------------------------------------------
603# Update icon cache
604# requires: gtk+
605#
c3bcd10e 606%update_icon_cache() {{ \
fb59e475 607 umask 022; \
072f4b80 608 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
609};} \
610%{nil}
fb59e475 611
f93109a0 612#-----------------------------------------------------------------
613# Update scrollkeeper database
614# requires: scrollkeeper
615#
616%scrollkeeper_update_post() \
f93109a0 617 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 618%{nil}
f93109a0 619
620%scrollkeeper_update_postun() \
f27cf2fd 621if [ "$1" = "0" ]; then \
f93109a0 622 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 623fi; \
f93109a0 624%{nil}
625
9c404149
AM
626#-----------------------------------------------------------------
627# post %install sequence:
628# - autodeps exceptions
629# - compress all man and info pages,
630# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 631# - compress kernel modules if any
9c404149
AM
632
633###################################################################
634# Requires/Provides automation
3e202b06 635# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 636#
2892b5df
JB
637%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
638%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
639%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
640%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
641%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 642
338726a6
JB
643#%_noautocompressdoc %{nil}
644#
8f74418b
MM
645%_missing_doc_files_terminate_build 1%{nil}
646%_unpackaged_files_terminate_build %{nil}
8781dc74 647# (X)emacs support
d77dcb61 648%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
649%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
650%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 651
02b58f60
JK
652%__php_provides %{nil}
653%__php_requires %{nil}
654%__perl_provides %{nil}
655%__perl_requires %{nil}
fa3497cd 656%__mono_provides %{nil}
657%__mono_requires %{nil}
25043cd4
AF
658
659# Perl specific macro definitions.
c94807f3
ER
660%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
661%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
662%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
663%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
664%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
665%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 666
45c00b39 667# Ruby
c94807f3
ER
668%__ruby /usr/bin/ruby
669%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
670%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
671%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
672%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
673%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
674%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
675%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 676%ruby_rdocdir /usr/share/rdoc
c94807f3 677%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
678%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
679%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 680
7ccf7643 681%php_pear_dir /usr/share/pear
7813c433 682%php_data_dir /usr/share/php
c94807f3
ER
683%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
684%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
685%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 686
0c5d1b9b 687# extract php/zend api versions
c94807f3
ER
688%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
689%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
690%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
691%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
692%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
693%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
694%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
695
696# helper macro
f952c0f3 697%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
698
699# macros for public use
700# for php extensions (php-pecl)
68b68193 701%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 702%{__php_api_requires zend_module_api} \
f952c0f3
ER
703%{__php_api_requires -v %php_major_version debug php_debug} \
704%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 705
c1b2705c
ER
706# for zend extensions
707%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 708%{__php_api_requires zend_extension_api} \
f952c0f3
ER
709%{__php_api_requires -v %php_major_version debug php_debug} \
710%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 711
934c685f
ER
712# for php pdo modules (php-pecl-PDO_*)
713%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
714
6c3b8203
ER
715# for using PHP post scripts. for PHP >= 5.0
716%php_webserver_restart \
717[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 718[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
719if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
720 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
721 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
722 %service -q php-fcgi restart \
723 fi \
724fi \
6c3b8203
ER
725%{nil}
726
727# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
728%php4_webserver_restart \
729[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 730[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
731if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
732 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
733 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
734 %service -q php-fcgi restart \
735 fi \
736fi \
6c3b8203
ER
737%{nil}
738
578e9248 739# X.org helper macros
434ab5a2
ER
740%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
741%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
742
c94807f3
ER
743%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
744%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
745%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
746%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
747%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 748
434ab5a2 749%requires_xorg_xserver_extension \
97486460
AM
750%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
751%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
752%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
753%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
754%{nil}
755
756%requires_xorg_xserver_xinput \
97486460
AM
757%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
758%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
759%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
760%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
761%{nil}
762
763%requires_xorg_xserver_font \
97486460
AM
764%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
765%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
766%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
767%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
768%{nil}
769
770%requires_xorg_xserver_videodrv \
97486460
AM
771%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
772%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
773%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
774%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 775%{nil}
578e9248 776
25043cd4
AF
777# Python specific macro definitions.
778# python main version
2383a9da 779%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
780
781# directories
2383a9da 782%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 783%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 784%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 785%py_incdir /usr/include/python%{py_ver}
7ccf7643 786%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 787%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 788%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
789
790# pure python modules compilation
3241033b 791%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 792
3241033b 793%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
794
795# Software written in Python language require Python with main version
e63cd81d 796%pyrequires_eq() Requires: %1
25043cd4 797
f12c2314 798# Hardlink binary identical .pyc and .pyo files
f12c2314 799%__spec_install_post_py_hardlink {\
53d5af13 800%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
801local a b c=0 t=0; \
802if [ -d "$RPM_BUILD_ROOT" ]; then \
803 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
804 while read a; do \
805 b="${a%.pyc}.pyo"; \
806 if cmp -s "$a" "$b"; then \
807 ln -f "$a" "$b"; \
808 c=$((c + 1)); \
809 fi; \
810 t=$((t + 1)); \
811 done < __rpm_pyc; \
812 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
813 rm -f __rpm_pyc; \
814fi; \
53d5af13 815}; __spec_install_post_py_hardlink } }
f12c2314 816
9227b3f9 817# remove python sources, so that check-files won't complain
f12c2314 818%py_postclean() \
0f82e280 819for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 820 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
821done \
822%{nil}
823
0fc5cff8 824# depmod macro
825%depmod() { \
f6148427 826umask 022; \
0fc5cff8 827if [ -e /boot/System.map-%1 ]; then \
3241033b 828 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 829else \
3241033b
ER
830 if [ -e /boot/System.map ]; then \
831 /sbin/depmod -a -F /boot/System.map %1; \
832 else \
833 /sbin/depmod -a %1; \
834 fi \
0fc5cff8 835fi; \
836}
837
2afc6e64 838# XMMS specific macros
c94807f3
ER
839%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
840%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
841%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
842%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
843%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
844%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
845%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
846%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
847%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
848%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
849
850%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 851
848c0d68 852# user/group checking macros
853#
854# Usage:
855# %userremove myuser
856#
857%userremove /usr/lib/rpm/user_group.sh user del
858%groupremove /usr/lib/rpm/user_group.sh group del
859#
860# Usage:
861# if %usertestrm myuser; then
862# /usr/sbin/userdel -r myuser
863# Note:
864# use these macros only if you need to call userdel/groupdel with
865# a non-standard option or take an extra action; otherwise use the
866# %userremove/%groupremove macros
867#
868%usertestrm /usr/lib/rpm/user_group.sh user testrm
869%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
870# user group membership management macros
871#
872# Usage:
873# %addusertogroup myuser agroup
874#
875%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 876
877# banner support (useful in {pre,post}{,un} and triggers)
878#
879# Usage:
aa41c920 880# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 881# the banner text, the banner text
aa41c920
ER
882# the banner text, and following line
883#EOF
884# You can use any form of here-document, <<'EOF' <<-EOT will do.
885# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
886#
72fcfcb3 887# -a - append to the banner
a8b9562a 888# -e - send to stderr instead of stdout
628754cb 889# -n - no show banner (overrides -t)
890# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
891#
892# Tests:
893# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
894# rpm -E 'date | %banner -e banner' > m; sh -x m
895#
afb54f6c 896%banner(aent:) ( \
1b334fe4 897RPM_SCRIPTVERBOSITY=5 \
898[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
899if [ -x /usr/bin/banner.sh ]; then \
aa41c920 900 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 901else \
a8b9562a 902 CMD="cat%{-e: >&2}" \
1b334fe4 903fi \
276a7b45
ER
904eval $CMD %{?2:%2}%{?3: %3}) \
905%{nil}
628754cb 906
990bd03f 907# useradd/groupadd macros
4c73bc69 908# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
909#
910# Usage:
911# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
912# [-g initial_group] [-G group[,...]] login
913#
914# -u uid. REQUIRED
915# -g gid/group. REQUIRED
916# -s defaults to /bin/false
917# -d defaults to /usr/share/empty
918# -c No default
919# -r is accepted but ignored (it's always set)
6bd4c218 920# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
921# rpm specific flags
922# -P package name. defaults to %{name}
923#
90627280 924%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
925%{!-u:%{error:useradd: Required argument -u missing}} \
926%{!-g:%{error:useradd: Required argument -g missing}} \
927%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
928if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
929 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
930 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
931 exit 1 \
932 fi \
933else \
934 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
935 /usr/sbin/useradd \\\
b5a7d552 936 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
937 -u %{-u*} \\\
938 -r \\\
939 -d %{-d*}%{!-d:/usr/share/empty} \\\
940 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 941 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
942 -g %{-g*} \\\
943 %{-M} \\\
944 %{-G:-G %{-G*}} \\\
1aac682a 945 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 946 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
947fi;
948
90627280
ER
949# Usage:
950# %groupadd [-P package] [-g gid] group
951#
952# -g gid. REQUIRED
953#
954# Sample:
955# %groupadd -P %{name}-base -g %{gid} %{name}
956
957%groupadd(g:P:rfo) \
9ba02ba9
ER
958%{!-g:%{error:groupadd: Required argument -g missing}} \
959%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 960if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
961 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
962 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
963 exit 1 \
964 fi \
965else \
966 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 967 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 968 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 969fi;
7cb77741 970
7c50f037 971# webapp macros
4c73bc69 972# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
973#
974# The config is installed/removed inside trigger, this means that you can any
975# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 976# updated. if you don't need the config for various reason for specific
35663282
ER
977# webserver, just remove the symlink from config directory using webapp
978# program. the trigger will not recreate the symlink on upgrades. In other
979# words the config is linked to webserver config directory on first install of
980# PACKAGE or WEBSERVER.
981#
7c50f037
ER
982# Add package's webserver config to webserver webapps dir.
983# Usage:
df979130 984# %webapp_register WEBSERVER WEBAPP
35663282
ER
985#
986%webapp_register() \
987%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
988if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
989 /usr/sbin/webapp register %1 %2\
990fi\
694a8f2e 991# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 992if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 993 %{expand:%service -q %%1 reload}\
35663282
ER
994fi\
995%{nil}
996
997# Remove package's config from webserver webapps dir.
35663282 998# Usage:
531c0efc
ER
999# %webapp_register [-f] WEBSERVER WEBAPP
1000%webapp_unregister(f) \
35663282
ER
1001%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1002# remove link if either of the packages are gone \
5d3a09a3 1003if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1004 /usr/sbin/webapp unregister %1 %2\
16897aea 1005 %{expand:%service -q %%1 reload}\
35663282
ER
1006fi \
1007%{nil}
1008
462b26fa 1009# service macro.
4c73bc69 1010# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1011#
1012# calls usual service restart on package %post, but skips the restart if
1013# administrator has disabled automatic service restarts in either global
1014# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1015#
462b26fa 1016# Usage:
7377b5ca 1017# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1018#
a0bbe604 1019# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1020# -n NOOP mode, do not actually restart service
462b26fa 1021#
7377b5ca
ER
1022# Requirements:
1023# BuildRequires: rpmbuild(macros) >= 1.268
1024# Requires: rc-scripts
1025# -n option:
1026# BuildRequires: rpmbuild(macros) >= 1.450
1027%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1028
1029
f9aa75bf
ER
1030# Java macros. based on jpackage macros.java
1031#
1032# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1033%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1034
1035# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1036%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1037
1038# Root directory for all Java VM/SDK/JRE's private things.
1039%_jvmprivdir %{_libdir}/jvm-private
1040
1041# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1042%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1043
1044# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1045%_jvmdatadir %{_datadir}/jvm
1046
1047# Root directory for all configurations parts of Java VM/SDK/JRE's
1048%_jvmsysconfdir %{_sysconfdir}/jvm
1049
1050# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1051%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1052
1053# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1054%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1055
1056# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1057%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1058
1059# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1060%_jnidir %{_libdir}/java
f9aa75bf 1061
c94807f3 1062%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1063
a9254650 1064%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1065%jar %{java_home}/bin/jar
c94807f3 1066%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1067%javac %{java_home}/bin/javac
1068%javadoc %{java_home}/bin/javadoc
6aedae62 1069
fe6c4bdd 1070%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1071
1072%jpackage_script() \
3ca65b87
ER
1073install -d $RPM_BUILD_ROOT%{_bindir}\
1074cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1075#!/bin/sh\
1076#\
1077# %{name} script\
1078# JPackage Project <http://www.jpackage.org/>\
1079\
1080# Source functions library\
1081. %{_javadir}-utils/java-functions\
1082\
1083# Source system prefs\
3ca65b87 1084if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1085 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1086fi\
1087\
1088# Source user prefs\
3ca65b87
ER
1089if [ -f $HOME/.%{name}rc ]; then\
1090 . $HOME/.%{name}rc\
6aedae62
ER
1091fi\
1092\
1093# Configuration\
1094MAIN_CLASS=%1\
1095BASE_FLAGS=%2\
1096BASE_OPTIONS=%3\
3ca65b87 1097BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1098\
1099# Set parameters\
1100set_jvm\
3ca65b87
ER
1101set_classpath $BASE_JARS\
1102set_flags $BASE_FLAGS\
1103set_options $BASE_OPTIONS\
6aedae62
ER
1104\
1105# Let's start\
3ca65b87 1106run "$@"\
6aedae62
ER
1107EOF
1108
06f11871
ER
1109# jpackage 1.7
1110# Directory for maven depmaps
1111#
1112%_mavendepmapdir /etc/maven
1113%_mavendepmapfragdir /etc/maven/fragments
1114
1115#
1116# add_to_depmap adds an entry to the depmap. The arguments are:
1117#
1118# %1 the original groupid
1119# %2 the original artifact id
1120# %3 the version
1121# %4 the new groupid
1122# %5 the new artifactid
1123#
1124
1125%add_to_maven_depmap() \
1126install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1127cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1128<dependency>\
1129 <maven>\
1130 <groupId>%1</groupId>\
1131 <artifactId>%2</artifactId>\
1132 <version>%3</version>\
1133 </maven>\
1134 <jpp>\
1135 <groupId>%4</groupId>\
1136 <artifactId>%5</artifactId>\
1137 <version>%3</version>\
1138 </jpp>\
1139</dependency>\
1140\
1141EOF\
1142%{nil}
1143
1144#==============================================================================
1145#
1146# update_maven_depmap updates the main maven depmap
1147#
1148%update_maven_depmap() \
1149echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1150if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1151cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1152fi\
1153echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1154
1155
59d3ebe9 1156# PEAR install macros
4c73bc69 1157# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1158#
1159# Usage:
f7ecf326 1160# %%pear_package_setup ...
dfce8b19 1161#
59d3ebe9 1162# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1163# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1164# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1165# -D - pass -D to %setup (so the build dir is not removed)
1166# -c - register channel from local channel.xml file
dfce8b19
ER
1167#
1168# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1169# destination hierarchy. you should copy the tree to buildroot after
1170# patching/reorganizing with %%pear_package_install.
1171#
1172# additionally BUILDROOT is stripped from files and files are converted to UNIX
1173# line endings.
1174#
1175# the pear install process output is recorded to install.log, you should put it
8763f51e 1176# to %%doc for later debug or just for information.
dfce8b19
ER
1177#
1178# additionally additional-packages.txt is produced if it was detected that the
1179# package has optional dependencies. the file format is suitable of displaying
1180# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1181# automatically added for this file.
59d3ebe9
ER
1182
1183
1184# records install.log and transforms PEAR names to PLD Linux rpm package names.
1185%__pear_install_log \
1186tee install.log \
1187# make post message of optional packages \
f64d1bb2 1188grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1189if [ -s optional-packages.txt ]; then \
1190 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1191else \
1192 rm -f optional-packages.txt \
1193fi \
1194%{nil}
1195
1196# command invoking pear cli
1197%__pear /usr/bin/pear
1198
67a089ff 1199%pear_install(a:n:zD) \
59d3ebe9 1200%__pear \\\
f7ecf326 1201 -c %{builddir}/pearrc \\\
dfce8b19 1202 -d doc_dir=/docs \\\
f7ecf326
ER
1203 -d temp_dir=/tmp \\\
1204 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1205 -d bin_dir=%{_bindir} \\\
1206 -d data_dir=%{php_pear_dir}/data \\\
1207 -d test_dir=%{php_pear_dir}/tests \\\
1208 install \\\
59d3ebe9 1209 --packagingroot=%{builddir} \\\
dfce8b19
ER
1210 --offline \\\
1211 --nodeps \\\
1212 %{-f:--force} \\\
67a089ff 1213 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1214 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1215%{nil}
1216
1217# The main macro.
1218# using this macro will append optional-packages.txt to the nocompressdoc list
1219# as it's displayed to user after package install. and adding additional gzip
1220# dep is just waste ;)
f7ecf326 1221%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1222%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1223%define builddir %{_builddir}/%{srcdir} \
1224%setup -q -c -T %{-D:-D} -n %{srcdir} \
1225%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1226%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1227%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1228%pear_install \
59d3ebe9
ER
1229%{-z:cd ..} \
1230cat %{-z:$_N/}.install.log | %__pear_install_log \
1231\
dfce8b19 1232# undos sources \
2a80e4cf 1233find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1234%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1235%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1236%{nil}
1237
7bef60e8 1238# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1239# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1240%pear_package_install() \
1241cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1242find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1243# help the developer out a little: \
1244if [ -f _noautoreq ]; then \
1245 echo "AutoReqdep detected:" \
1246 echo "_noautoreq $(cat _noautoreq)" \
1247fi \
1248%{nil}
1249
0d5dd00c
ER
1250
1251# Register OpenLDAP schema.
4c73bc69 1252# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1253#
1254# Usage:
1255# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1256#
1257# -d specify dependant schemas, separated by comma
1258#
1259%openldap_schema_register(d:) \
1260for schema in %*; do \
1261 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1262 %{__sed} -i -e " \
1263 /^include.*local.schema/{ \
1264 iinclude\\t $schema\
1265 } \
1266 " /etc/openldap/slapd.conf \
1267 fi \
1268done \
1269# enable dependant schemas \
1270if [ "%{-d*}" ]; then \
1271 %{__sed} -i -e ' \
1272 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1273 s/^#// \
1274 }' /etc/openldap/slapd.conf \
1275fi \
1276%{nil}
1277
1278# Unregister OpenLDAP schema.
4c73bc69 1279# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1280#
1281# Usage:
1282# %%openldap_schema_unregister %{schemadir}/horde.schema
1283#
1284%openldap_schema_unregister() \
1285for schema in %*; do \
1286 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1287 %{__sed} -i -e " \
1288 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1289 # for symmetry it would be nice if we disable enabled schemas in post, \
1290 # but we really can not do that, it would break something else. \
1291 " /etc/openldap/slapd.conf \
1292 fi \
1293done \
1294%{nil}
1295
b0bc2936 1296%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1297
dcc6baf7 1298
1299# Build modules for kernels 2.6
1300# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1301#
1302# Usage:
aa559e46 1303# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1304#
1305# remember that proper Makefile is still required
1306# Options:
990bd03f 1307# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1308# without .ko extension, may be placed in subdirectory
aa559e46 1309# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1310# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1311# -c -- do not execute make clean
dcc6baf7 1312# <additional arguments> -- all additional arguments will be passed to
1313# make modules
1314#
1315# Additional patching supported via here document. Try:
1316# %build_kernel_modules -m module <<'EOF'
1317# your patch script here
1318# EOF
1319# Don't use it unless patching depends on config options.
1320
1321# Developer note: don't touch it unless you know how to handle '\'.
1322# - \ in script expands to nothing
1323# - \\\ in script expands to \
566398b4 1324# - \\\ inside definition expands to nothing
dcc6baf7 1325# - \\\\\\\ inside definition expands to \
1326# - in last line \ has to touch arguments so arguments passing
1327# in new lines (using \) will be supported
1328
5a81d83e 1329%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1330%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1331 \
1332%define Opts \\\\\\\
1333%if "%{_target_base_arch}" != "%{_arch}" \\\
1334 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1335 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1336 %else \\\
1337 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1338 %endif \\\
1339%else \\\
88608ef7 1340 CC="%{kgcc}" \\\
dcc6baf7 1341%endif \
88608ef7 1342%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1343 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1344 \
e364bc26 1345%{?-C:cd %{-C*}} \
dcc6baf7 1346compile() { \
ba9de9b2
ER
1347 local L="<" PATCH_SH; \
1348 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1349 set -e -x \
730239f9 1350 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1351 \
730239f9 1352for cfg in ${cfgs:-dist}; do \
dcc6baf7 1353 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1354 \
c546f6fb 1355 rm -rf o \
68cfe9d9 1356 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1357 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1358 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1359 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1360 \
1361 set +x \
1362 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1363 set -x \
1364 \
c768535c 1365 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1366 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1367 %{-p*} %{-P*} \\\
1368 %{MakeOpts} \
1369 %else \
1370 install -d o/include/config \
1371 touch o/include/config/MARKER \
588f1b0b 1372 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1373 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1374 %endif \
1375 \
5a81d83e 1376 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1377 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1378 ${1+"$@"} \\\
5a81d83e 1379 M=$PWD %{MakeOpts}} \
f635907b 1380 \
dcc6baf7 1381 %{__make} -C %{_kernelsrcdir} modules \\\
1382 ${1+"$@"} \\\
1383 M=$PWD %{MakeOpts} \
1384 \
1385 for MODULE in {%{-m*},}; do \
1386 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1387 done \
1388done \
aa559e46 1389%{?-C:cd -} \
dcc6baf7 1390} \
1391compile %{*}\
1392%{nil}
1393
1394
1395# Install kernel modules built by %build_kernel_modules
1396# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1397#
1398# Usage:
1399# %install_kernel_modules -m <modules> -d <directory>
1400#
1401# Options:
990bd03f 1402# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1403# without .ko extension, may be placed in subdirectory
1404# -d <directory> (required) -- in what subdirectory modules should be
1405# installed (eg. misc, kernel/drivers/net)
1406# -s <suffix> -- suffix to use when installing modules, useful when module
1407# with same name exists in kernel already
1408# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1409# for defining aliases, only useful with -s
dcc6baf7 1410
1411%install_kernel_modules(m:d:s:n:) \
1412%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1413%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1414%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1415 \
1416%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1417%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1418 \
730239f9 1419local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1420 \
1421for MODULE in {%{-m*},}; do \
1422 [ -n "${MODULE}" ] || continue \
730239f9
ER
1423 for cfg in ${cfgs:-dist}; do \
1424 [ "$cfg" = smp ] && suf=smp || suf= \
1425 MNAME=${MODULE##*/} \
1426 install -D ${MODULE}-$cfg.ko \\\
1427 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1428 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1429 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1430 >> %{ModprobeD}$suf/%{-n*}.conf} \
1431 done \
dcc6baf7 1432done \
1433%{nil}
1434
fa65356c 1435# patchset macros
4c73bc69 1436# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1437#
1438# Usage:
1439# %patchset_source -f <seq(1) format> <start> [<end>]
1440# %patchset_patch <start> [<end>]
1441#
1442# If <end> is omited, it is assumed to be <start>.
1443#
1444# For example in preamble:
1445# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1446# and in %prep:
1447# %patchset_patch 33 44
1448
1449# generate SourceX urls from range START STOP
1450# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1451# The sources start from 10000
e91610db 1452%patchset_source(f:b:) %(
44f733ef 1453 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1454 start=$(expr $base + %1);
1455 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1456 # we need to call seq twice as it doesn't allow two formats
1457 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1458 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1459 paste %{tmpdir}/__ps{1,2};
1460 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1461) \
1462%{nil}
fa65356c
ER
1463
1464# apply sources from %patchset_source
1465# -p specify -pX for %patch line
1466# -b base offset: defaults to 10000
1467%patchset_patch(f:p:b:) %(
44f733ef 1468 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1469 start=$(expr $base + %1);
1470 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1471 echo ": patchset_patch %1%{?2: to %2}";
1472 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1473) \
1474%{nil}
fa65356c 1475
5730b44b 1476# browser plugins v2
4c73bc69 1477# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1478#
1479# Usage:
1480# %browser_plugins_add_browser <name> -p <plugindir>
1481#
1482# <name> (required) -- name of the browser. usually %{name}.
1483# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1484# -b -- default blacklists
1485# -a <arch> override arch
5730b44b
ER
1486#
1487# Example:
1488# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1489
1490%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1491%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1492%update_browser_plugins /usr/sbin/update-browser-plugins || :
1493
02ebf70f 1494%browser_plugins_add_browser(p:b:a:) \
9efd458e 1495 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1496 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1497 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1498 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1499 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1500 %{-b:cat >> $blacklist_file %{-b*}} \
1501%{nil}
1502
ad17b654
ER
1503# Helper for LUA.
1504# split string separated by space into quoted list
1505#
4c73bc69 1506# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1507#
1508# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1509%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1510
1511# adjust /etc/shells by adding and removing shells from there
4c73bc69 1512# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1513#
1514# Usage:
d9b789d9
ER
1515# %post -p <lua>
1516# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1517#
d9b789d9
ER
1518# %preun -p <lua>
1519# if arg[2] == 0 then
1520# %lua_remove_etc_shells /bin/bash /bin/rbash
1521# end
7377b5ca
ER
1522#
1523# Requirements:
d9b789d9
ER
1524# BuildRequires: rpmbuild(macros) >= 1.462
1525#
ad17b654 1526
d9b789d9 1527%lua_add_etc_shells() \
ad17b654
ER
1528t = {}\
1529f = io.open("/etc/shells", "r")\
1530if f then\
1531 for l in f:lines() do t[l]=l; end\
1532 f:close()\
1533end\
1534for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1535 if not t[s] then\
b8c0bc18 1536 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1537 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1538 end\
1539end\
1540%{nil}
1541
d9b789d9
ER
1542%lua_remove_etc_shells() \
1543t = {}\
1544f = io.open("/etc/shells", "r")\
1545if f then\
1546 for l in f:lines() do t[l]=l; end\
1547 f:close()\
1548end\
1549for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1550 print("Removing "..l.." from /etc/shells")\
1551 t[l] = nil\
1552end\
1553s=""\
1554for _, l in pairs(t) do\
1555 s=s..l.."\\n"\
1556end\
1557io.open("/etc/shells", "w"):write(s)\
1558%{nil}
1559
1560# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1561#
1562# Author: Elan Ruusamäe <glen@pld-linux.org>
1563#
1564# Usage:
1565# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1566# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1567#
1568# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1569#
1570# Requirements:
1571# BuildRequires: rpmbuild(macros) >= 1.429
1572#
1573%add_etc_shells(p) %{-p:<lua>}\
1574%{expand:%%lua_add_etc_shells %*}\
1575%{nil}
1576
ad17b654 1577%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1578%{-p:if arg[2] == 0 then}\
d9b789d9 1579%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1580%{-p:end} \
ad17b654
ER
1581%{nil}
1582
75bd6249
ER
1583# Check syntax for Python files
1584#
1585# Author: Elan Ruusamäe <glen@pld-linux.org>
1586# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1587#
1588# Usage:
1589# %py_lint src
1590#
1591# Requirements:
1592# BuildRequires: python
1593# BuildRequires: rpmbuild(macros) >= 1.469
1594
1595%py_lint() \
1596__py_lint() { \
1597find "$@" -type f -name '*.py' | python -c ' \
1598import sys \
1599import compiler \
1600\
1601err = 0\
1602for f in sys.stdin: \
1603 fd = open(f.strip()) \
1604 c = fd.read() \
1605 fd.close() \
1606 try: \
1607 compiler.parse(c) \
1608 except SyntaxError, e: \
1609 print "py_lint: %s: %s" % (f.strip(), e) \
1610 err = err + 1\
1611\
1612if err: \
1613 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1614 sys.exit(1) \
1615else: \
1616 print >> sys.stderr, "py_lint: Found no syntax errors." \
1617' \
1618}; __py_lint %* \
1619%{nil}
1620
59d3ebe9 1621# vim:ts=4 sw=4 noet syn=spec
This page took 0.413353 seconds and 4 git commands to generate.